# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from stark_ros_msgs/CompressedTensor.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

from ._NDArray import *
from ._TensorAxis import *

class CompressedTensor(genpy.Message):
  _md5sum = "e7890ff62629e6ca6d3040b149aa7015"
  _type = "stark_ros_msgs/CompressedTensor"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# N dimensional tensor with zero suppressed encoding

# spec for each axis
stark_ros_msgs/TensorAxis[] axes

# indices (length num fields, each array has N entries)
# this was chosen since this is the result from np.nonzero
stark_ros_msgs/NDArray[] indices

# 1D values at each index (N entries)
# this array determines the tensor dtype
stark_ros_msgs/NDArray values

================================================================================
MSG: stark_ros_msgs/TensorAxis
# axis name
string name

# Centers along axis (required)
stark_ros_msgs/NDArray centers

# Edges around centers (optional)
stark_ros_msgs/NDArray edges

================================================================================
MSG: stark_ros_msgs/NDArray
# Packed, single dtype Numpy array

# dtype from enumeration in DTypes.msg
uint8 dtype

# Array shape
uint64[] shape

# Row(C)/Column(Fortran) major (off by default)
# https://en.wikipedia.org/wiki/Row-_and_column-major_order
bool is_column_major

# Is the data blob bigendian? (off by default)
bool is_bigendian

# Array data
uint8[] data
"""
  __slots__ = ['axes','indices','values']
  _slot_types = ['stark_ros_msgs/TensorAxis[]','stark_ros_msgs/NDArray[]','stark_ros_msgs/NDArray']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       axes,indices,values

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CompressedTensor, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.axes is None:
        self.axes = []
      if self.indices is None:
        self.indices = []
      if self.values is None:
        self.values = NDArray()
    else:
      self.axes = []
      self.indices = []
      self.values = NDArray()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.axes:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.centers
        _x = _v1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*_v1.shape))
        _x = _v1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v2 = val1.edges
        _x = _v2.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v2.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*_v2.shape))
        _x = _v2
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v2.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.indices)
      buff.write(_struct_I.pack(length))
      for val1 in self.indices:
        _x = val1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.shape))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.values.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.values.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.values.shape))
      _x = self
      buff.write(_get_struct_2B().pack(_x.values.is_column_major, _x.values.is_bigendian))
      _x = self.values.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.axes is None:
        self.axes = None
      if self.indices is None:
        self.indices = None
      if self.values is None:
        self.values = NDArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.axes = []
      for i in range(0, length):
        val1 = TensorAxis()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _v3 = val1.centers
        start = end
        end += 1
        (_v3.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v3.shape = s.unpack(str[start:end])
        _x = _v3
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v3.is_column_major = bool(_v3.is_column_major)
        _v3.is_bigendian = bool(_v3.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v3.data = str[start:end]
        _v4 = val1.edges
        start = end
        end += 1
        (_v4.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v4.shape = s.unpack(str[start:end])
        _x = _v4
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v4.is_column_major = bool(_v4.is_column_major)
        _v4.is_bigendian = bool(_v4.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v4.data = str[start:end]
        self.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.indices = []
      for i in range(0, length):
        val1 = NDArray()
        start = end
        end += 1
        (val1.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shape = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        val1.is_column_major = bool(val1.is_column_major)
        val1.is_bigendian = bool(val1.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.indices.append(val1)
      start = end
      end += 1
      (self.values.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.values.shape = s.unpack(str[start:end])
      _x = self
      start = end
      end += 2
      (_x.values.is_column_major, _x.values.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.values.is_column_major = bool(self.values.is_column_major)
      self.values.is_bigendian = bool(self.values.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.values.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.axes:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v5 = val1.centers
        _x = _v5.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v5.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(_v5.shape.tostring())
        _x = _v5
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v5.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v6 = val1.edges
        _x = _v6.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v6.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(_v6.shape.tostring())
        _x = _v6
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v6.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.indices)
      buff.write(_struct_I.pack(length))
      for val1 in self.indices:
        _x = val1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.shape.tostring())
        _x = val1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.values.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.values.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.values.shape.tostring())
      _x = self
      buff.write(_get_struct_2B().pack(_x.values.is_column_major, _x.values.is_bigendian))
      _x = self.values.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.axes is None:
        self.axes = None
      if self.indices is None:
        self.indices = None
      if self.values is None:
        self.values = NDArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.axes = []
      for i in range(0, length):
        val1 = TensorAxis()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _v7 = val1.centers
        start = end
        end += 1
        (_v7.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v7.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = _v7
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v7.is_column_major = bool(_v7.is_column_major)
        _v7.is_bigendian = bool(_v7.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v7.data = str[start:end]
        _v8 = val1.edges
        start = end
        end += 1
        (_v8.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v8.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = _v8
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v8.is_column_major = bool(_v8.is_column_major)
        _v8.is_bigendian = bool(_v8.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v8.data = str[start:end]
        self.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.indices = []
      for i in range(0, length):
        val1 = NDArray()
        start = end
        end += 1
        (val1.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = val1
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        val1.is_column_major = bool(val1.is_column_major)
        val1.is_bigendian = bool(val1.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.indices.append(val1)
      start = end
      end += 1
      (self.values.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.values.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 2
      (_x.values.is_column_major, _x.values.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.values.is_column_major = bool(self.values.is_column_major)
      self.values.is_bigendian = bool(self.values.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.values.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
